import java.util.Scanner;

public class Mario {
    
    public static void main(String[] args){
 
        Scanner scan = new Scanner(System.in);

        //Variaveis para armazenar as entradas
        int N, L;
        
        //O tamanho do arranjo eh equivalente ao numero maximo possivel de armarios livres
        int [] armarios = new int [100000];
        
        //Variaveis auxiliares
        int melhor, i, j;
        
        //Armazena a primeira entrada nas variaveis adequadas para verificar a condicao de parada
        N = scan.nextInt();
        L = scan.nextInt();

        //Laco que recebe os casos de teste enquanto a condicao de parada nao for satisfeita
        while (N!=0 || L!=0) {
             
        	//Coloca as posicoes dos armarios livres recebida na entrada, no vetor de armarios
            for (i = 0; i < L; i++) armarios[i] = scan.nextInt();
             
            //Inicializacao das variaveis auxiliares
            melhor = 0;
            i = 0;
            j = 0;
            
            /*	Laco para maximizar o numero de posicoes contiguas
             *	Enquanto o numero necessario de posicoes contiguas nao for atingido
             *	e nao estourar o limite de armarios livres, o laco eh executado 
             */ 
            while (melhor < N && j < L) {
                
            	/*	O objetivo eh conseguir n posicoes contiguas utilizando o maximo de armarios livres possivel,
            	 *	a fim de minimizar o numero de trocas no final.
            	 *
            	 *		A condicao abaixo verifica se entre o armario disponivel na posicao i e o armario disponivel
            	 *	na posicao j, existe espaco suficiente para n armarios. 
            	 */
            	if (armarios[j] < armarios[i] + N) {
            		/*		Caso nao haja espaco suficiente, verifica-se quantos armarios livres existem entre 
            		 *	os 2 (j-1 + 1) e se esse eh numero maximo ate o momento, entao, o intervalo eh expandido (j++)
            		 *  para a proxima verificacao.
            		 */  
            		
                    melhor = Math.max(melhor, j-i + 1);
                    j++;
                }
            	//		Caso contrario, diminui-se o intervalo analisado (i--) 
                else i++;
            }
            
            //O numero de trocas eh o numero de armarios necessario menos o numero maximo de armarios livres proximos encontrado
            System.out.printf("%d\n", N - melhor);
            
            //Recebe as proximas entradas
            N = scan.nextInt();
            L = scan.nextInt();
        }
    }
}